#ifndef MAFICO_COLLECT
#define MAFICO_COLLECT

#include <algorithm>
#include <numeric>

namespace mafico
{

// collect(Container<T>, (C, T) -> C, C) -> C
template <
    template <typename> typename Container,
    typename T,
    typename CollectF,
    typename C = T>
[[nodiscard]] auto collect(const Container<T>& c, CollectF&& f, C init = {})
{
    C result = init;

    return std::accumulate(
        c.begin(), c.end(), init,
        std::forward<CollectF>(f));
}

}

#endif
