#include <mafico/filter.hpp>

#include <cmath>
#include <list>
#include <vector>

#include "test_common.hpp"

int main()
{
    std::vector<double> numbers{1.0, 1.1, 2.0, 3.5, 3.8, 4.0, 5.0, 5.5};
    constexpr auto is_integer = [](auto n){ return std::rint(n) == n; };
    auto integers = mafico::filter(numbers, is_integer);

    test_cond((integers == std::vector{1.0, 2.0, 4.0, 5.0}));

    auto int_integers = mafico::filter_to<int>(numbers, is_integer);

    test_cond((int_integers == std::vector{1, 2, 4, 5}));

    std::list<std::list<int>> list_of_lists{
        {1, 2, 3, 4, 5},
        {2, 3, 5, 7, 11},
        {1, 4, 9, 16, 25},
        {},
        {},
        {-5, -4, -3, -2, -1}
    };

    auto empty = mafico::filter(list_of_lists, &std::list<int>::empty);

    test_cond((empty.size() == 2));
}
